// das Adressbuch speichert alle Kontakte und ermglicht, mit ihnen zu arbeiten

import java.util.*;
import java.io.*;

class Adressbuch implements Serializable {

	// unsere Liste mit den Kontakten
	ArrayList<Kontakt> adressbuch = new ArrayList<Kontakt>();

	// einen neuen Kontakt hinzufuegen
	void kontaktHinzufuegen () {
		Benutzereingabe eingabe = new Benutzereingabe();
		System.out.println ("Einen neuen Kontakt hinzugefuegen:");
		String vname = eingabe.getString("Vorname? ");
		String nname = eingabe.getString("Nachname? ");
		String telnr = eingabe.getString("Telefonnummer? ");
			
		Kontakt neuerKontakt = new Kontakt(vname, nname, telnr);
		adressbuch.add(neuerKontakt);
	}
	
	// alle Kontakte ausgeben
	void kontakteAusgeben () {
		for (Kontakt k : adressbuch) {
			kontaktAusgeben(k);
		}
	}
	
	// einen einzelnen Kontakt ausgeben (Hilfsmethode fuer kontakteSuchen())
	void kontaktAusgeben (Kontakt k) {
		System.out.println (k.getVorname() + " " + k.getNachname() + ":" + k.getTelefon());
	}	

	// nach Kontakt suchen
	void kontakteSuchen () {
		Benutzereingabe eingabe = new Benutzereingabe();
		String suchstring = eingabe.getString("Geben Sie den Namen oder die Telefonnummer ein, nach der Sie suchen moechten: ");
		for (Kontakt k : adressbuch) {
			if (k.suche(suchstring)) {
				kontaktAusgeben(k);
			}
		}
	}
	
	// das Adressbuch inkl. aller Kontakte serialisieren
	void adressbuchSpeichern() {
		try {
			ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(new File("adressbuch.ser")));
			os.writeObject(adressbuch);
			os.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	// das Adressbuch inkl. aller Kontakte deserialisieren
	void adressbuchLaden() {
		try {
			ObjectInputStream is = new ObjectInputStream(new FileInputStream(new File("adressbuch.ser")));
			Object obj = is.readObject();
			adressbuch = (ArrayList<Kontakt>) obj;
			is.close();
		} catch (FileNotFoundException ex) {
			System.out.println("Exception: Datei adressbuch.ser nicht gefunden!\n");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	// die Kontakte in einer Textdatei speichern: Name, Vorname und Tel.nr. eines Kontaktes durch ":" trennen
	void adressbuchExportieren() {
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(new File("adressbuch.txt")));
			for (Kontakt k : adressbuch) {
				writer.write (k.getVorname() + ":" + k.getNachname() + ":" + k.getTelefon());
				writer.newLine();  // neue Zeile beginnen
			}
			writer.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	// die Kontakte aus der Textdatei laden
	void adressbuchImportieren() {
		try {
			BufferedReader reader = new BufferedReader(new FileReader(new File("adressbuch.txt")));
			adressbuch.clear();	// alle alten Kontakte loeschen
			String zeile = "";
			while ((zeile = reader.readLine()) != null) {
				String[] felder = zeile.split(":");
				adressbuch.add(new Kontakt (felder[0], felder[1], felder[2]));
			}
			reader.close();
		} catch (FileNotFoundException ex) {
			System.out.println("Exception: Datei adressbuch.txt nicht gefunden!\n");
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}	
}